- 
                            Data Grids / Data Management
- 
                Data Grid
- Overview
 - 
                Data Binding
 - 
                Filtering
 - Sorting
 - 
                Editing
 - 
                Grouping
 - 
                Selection
 - Focused Row
 - Paging
 - 
                Scrolling
 - 
                Columns
 - 
                Master-Detail
 - 
                Data Summaries
 - 
                Drag & Drop
 - 
                Export to PDF
 - 
                Export to Excel
 - Appearance
 - 
                Customization
 - State Persistence
 - 
                Adaptability
 - 
                Keyboard Navigation
 - Right-To-Left Support
 
 - 
                Tree List
- Overview
 - 
                Data Binding
 - 
                Filtering
 - Sorting
 - 
                Editing
 - 
                Selection
 - Focused Row
 - Paging
 - 
                Columns
 - Drag & Drop
 - State Persistence
 - Adaptability
 - 
                Keyboard Navigation
 
 - 
                Card View
 - 
                Pivot Grid
- Overview
 - 
                Data Binding
 - 
                Field Management
 - 
                Data Summaries
 - Drill Down
 - Filtering
 - 
                Scrolling
 - 
                Export to Excel
 - Chart Integration
 - Customization
 - State Persistence
 
 - 
                Filter Builder
 
 - 
                
 - 
                            Data Visualization
- 
                Charts
- Overview
 - 
                Data Binding
 - 
                Common Concepts
- 
                Axis
 - 
                Aggregation
 - 
                Tooltips
 - 
                Selection
 - 
                Customization
 - 
                Zooming
 - 
                Export
 
 - 
                
 - 
                Area Charts
 - 
                Bar Charts
 - Bullet Charts
 - 
                Doughnut Charts
 - 
                Financial Charts
 - 
                Funnel and Pyramid Charts
 - 
                Line Charts
 - Pareto Chart
 - 
                Pie Charts
 - 
                Point Charts
 - 
                Polar and Radar Charts
 - 
                Range Charts
 - Sankey Chart
 - 
                Sparkline Charts
 - 
                Tree Map
 
 - 
                Gauges
- Overview
 - 
                Runtime update
 - 
                Bar Gauge
 - 
                Circular Gauge
 - 
                Linear Gauge
 
 - 
                Diagram
- Overview
 - 
                Data Binding
 - 
                Featured Shapes
 - 
                Custom Shapes
 - 
                Document Capabilities
 - 
                User Interaction
 - UI Customization
 - Adaptability
 
 
 - 
                
 - 
                            Scheduling / Planning
- 
                Scheduler
- Overview
 - 
                Data Binding
 - 
                Views
 - 
                Appointments
 - 
                Timetable
 - Editing
 - 
                Grouping
 - Virtual Scrolling
 - Drag & Drop
 - 
                Customization
 - Adaptability
 
 - 
                Gantt
- Overview
 - Data Binding
 - 
                Filtering
 - Sorting
 - Strip Lines
 - Export to PDF
 - Validation
 - 
                Customization
 
 
 - 
                
 - 
                            Messaging
 - 
                            WYSIWYG Editor
 - 
                            Forms
 - 
                            Data Editors
- Overview
 - 
                Common Concepts
 - 
                Calendar
 - Check Box
 - Color Box
 - 
                Date Box
 - 
                Date Range Box
 - 
                Number Box
 - Radio Group
 - 
                Range Selector
 - Range Slider
 - Slider
 - Speech To Text
 - Switch
 - Text Area
 - Text Box
 
 - 
                            Drop-Downs
- Autocomplete
 - 
                Drop Down Box
 - 
                Select Box
 - 
                Tag Box
 - 
                Lookup
 
 - 
                            Buttons
 - 
                            File Upload / File Management
- 
                File Manager
- Overview
 - 
                File System Types
 - 
                Customization
 
 - 
                File Uploader
 
 - 
                
 - 
                            Popup and Notifications
 - 
                            Navigation
- Overview
 - Accordion
 - 
                Action Sheet
 - 
                Context Menu
 - 
                Menu
 - Multi View
 - 
                Drawer
 - 
                Tab Panel
 - 
                Tabs
 - 
                Toolbar
 - 
                Stepper
 - Pagination
 - 
                List
 - 
                Tree View
 - Right-to-Left Support
 
 - 
                            Layout
 - 
                            Interactive Wrappers
- 
                Sortable
 - Resizable
 
 - 
                
 - 
                            Progress Indicators
 - 
                            Maps
- Overview
 - 
                Map
 - 
                Vector Map
- 
                Data Binding
 - Multiple Layers
 - 
                Markers
 - Legend
 - 
                Zooming and Panning
 - 
                Customization
 
 - 
                
 
 - 
                            Localization
 
Related Demos:
        
            Your search did not match any results.
        
    JavaScript/jQuery Data Grid - Overview
DevExtreme JavaScript DataGrid is a client-side grid control available as a jQuery component. This control supports binding to data from local arrays, JSON files, Web API, OData services, and custom remote services. Check out other demos in this section to explore more JavaScript DataGrid features, like data editing and validation, paging, scrolling, and so on.
To get started with the DevExtreme JavaScript DataGrid component, refer to the following tutorial for step-by-step instructions: Getting Started with JavaScript DataGrid.
For a complete overview of JavaScript DataGrid options, check the JavaScript DataGrid API Reference.
DevExtreme Accessibility Compliance
                        
                            DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
                        
                        
                            All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
                        
                    
                
                The overall accessibility level of your application depends on the DataGrid features used.
            
        
            
            Backend API
        
    $(() => {
  $('#gridContainer').dxDataGrid({
    dataSource: {
      store: {
        type: 'odata',
        version: 2,
        url: 'https://js.devexpress.com/Demos/SalesViewer/odata/DaySaleDtoes',
        key: 'Id',
        beforeSend(request) {
          const year = new Date().getFullYear() - 1;
          request.params.startDate = `${year}-05-10`;
          request.params.endDate = `${year}-5-15`;
        },
      },
    },
    paging: {
      pageSize: 10,
    },
    pager: {
      visible: true,
      showPageSizeSelector: true,
      allowedPageSizes: [10, 25, 50, 100],
    },
    remoteOperations: false,
    searchPanel: {
      visible: true,
      highlightCaseSensitive: true,
    },
    groupPanel: { visible: true },
    grouping: {
      autoExpandAll: false,
    },
    allowColumnReordering: true,
    rowAlternationEnabled: true,
    showBorders: true,
    width: '100%',
    columns: [
      {
        dataField: 'Product',
        groupIndex: 0,
      },
      {
        dataField: 'Amount',
        caption: 'Sale Amount',
        dataType: 'number',
        format: 'currency',
        alignment: 'right',
      },
      {
        dataField: 'Discount',
        caption: 'Discount %',
        dataType: 'number',
        format: 'percent',
        alignment: 'right',
        allowGrouping: false,
        cellTemplate: discountCellTemplate,
        cssClass: 'bullet',
      },
      {
        dataField: 'SaleDate',
        dataType: 'date',
      },
      {
        dataField: 'Region',
        dataType: 'string',
      },
      {
        dataField: 'Sector',
        dataType: 'string',
      },
      {
        dataField: 'Channel',
        dataType: 'string',
      },
      {
        dataField: 'Customer',
        dataType: 'string',
        width: 150,
      },
    ],
    onContentReady(e) {
      if (!collapsed) {
        collapsed = true;
        e.component.expandRow(['EnviroCare']);
      }
    },
  });
});
const discountCellTemplate = function (container, options) {
  $('<div/>').dxBullet({
    onIncidentOccurred: null,
    size: {
      width: 150,
      height: 35,
    },
    margin: {
      top: 5,
      bottom: 0,
      left: 5,
    },
    showTarget: false,
    showZeroLevel: true,
    value: options.value * 100,
    startScaleValue: 0,
    endScaleValue: 100,
    tooltip: {
      enabled: true,
      font: {
        size: 18,
      },
      paddingTopBottom: 2,
      customizeTooltip() {
        return { text: options.text };
      },
      zIndex: 5,
    },
  }).appendTo(container);
};
let collapsed = false;
    
    <!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
  <head>
    <title>DevExtreme Demo</title>
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
    <script src="https://cdn.jsdelivr.net/npm/cldrjs@0.5.5/dist/cldr.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/cldrjs@0.5.5/dist/cldr/event.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/cldrjs@0.5.5/dist/cldr/supplemental.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/cldrjs@0.5.5/dist/cldr/unresolved.js"></script>
    <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" />
    <script src="js/dx.all.js?v=25.1.6"></script>
    <link rel="stylesheet" type="text/css" href="styles.css" />
    <script src="index.js"></script>
  </head>
  <body class="dx-viewport">
    <div class="demo-container">
      <div id="gridContainer"></div>
    </div>
  </body>
</html>
    
    .dx-datagrid .dx-data-row > td.bullet {
  padding-top: 0;
  padding-bottom: 0;
}

import React from 'react';
import ODataStore from 'devextreme/data/odata/store';
import DataGrid, {
Column,
Grouping,
GroupPanel,
Pager,
Paging,
SearchPanel
} from 'devextreme-react/data-grid';
import DiscountCell from './DiscountCell.js';
const pageSizes = [10, 25, 50, 100];
const dataSourceOptions = {
store: new ODataStore({
url: 'https://js.devexpress.com/Demos/SalesViewer/odata/DaySaleDtoes',
beforeSend: function(request) {
request.params.startDate = '2018-05-10';
request.params.endDate = '2018-05-15';
}
})
};
class App extends React.Component {
constructor(props) {
super(props);
this.state = {
collapsed: false
};
this.onContentReady = this.onContentReady.bind(this);
}
render() {
return (
<DataGrid
dataSource={dataSourceOptions}
allowColumnReordering={true}
showBorders={true}
onContentReady={this.onContentReady}
>
<GroupPanel visible={true} />
<SearchPanel visible={true} highlightCaseSensitive={true} />
<Grouping autoExpandAll={false} />
<Column dataField="Product" groupIndex={0} />
<Column
dataField="Amount"
caption="Sale Amount"
dataType="number"
format="currency"
alignment="right"
/>
<Column
dataField="Discount"
caption="Discount %"
dataType="number"
format="percent"
alignment="right"
allowGrouping={false}
cellRender={DiscountCell}
cssClass="bullet"
/>
<Column dataField="SaleDate" dataType="date" />
<Column dataField="Region" dataType="string" />
<Column dataField="Sector" dataType="string" />
<Column dataField="Channel" dataType="string" />
<Column dataField="Customer" dataType="string" width={150} />
<Pager allowedPageSizes={pageSizes} showPageSizeSelector={true} />
<Paging defaultPageSize={10} />
</DataGrid>
);
}
onContentReady(e) {
if (!this.state.collapsed) {
e.component.expandRow(['EnviroCare']);
this.setState({
collapsed: true
});
}
}
}
export default App;
import React from 'react';
import Bullet, { Font, Margin, Size, Tooltip } from 'devextreme-react/bullet';
export default function DiscountCell(cellData) {
return (
<Bullet
showTarget={false}
showZeroLevel={true}
value={cellData.value * 100}
startScaleValue={0}
endScaleValue={100}
>
<Size width={150} height={35} />
<Margin top={5} bottom={0} left={5} />
<Tooltip
enabled={true}
paddingTopBottom={2}
zIndex={5}
customizeTooltip={customizeTooltip}
>
<Font size={18} />
</Tooltip>
</Bullet>
);
}
function customizeTooltip(data) {
return {
text: `${parseInt(data.value)}%`
};
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app')
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.dx-datagrid .dx-data-row > td.bullet {
padding-top: 0;
padding-bottom: 0;
}
System.config({
transpiler: 'plugin-babel',
paths: {
'npm:': 'https://unpkg.com/'
},
defaultExtension: 'js',
map: {
'react': 'npm:react@16/umd/react.development.js',
'react-dom': 'npm:react-dom@16/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'devextreme': 'npm:devextreme@19.2',
'devextreme-react': 'npm:devextreme-react@19.2',
'jszip': 'npm:jszip@3.1.3/dist/jszip.min.js',
'quill': 'npm:quill@1.3.7/dist/quill.js',
'devexpress-diagram': 'npm:devexpress-diagram',
'devexpress-gantt': 'npm:devexpress-gantt',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0/plugin-babel.js',
'systemjs-babel-build':
'npm:systemjs-plugin-babel@0/systemjs-babel-browser.js'
},
packages: {
'devextreme': {
defaultExtension: 'js'
},
'devextreme-react': {
main: 'index.js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true,
react: true
}
});

<template>
<DxDataGrid
:data-source="dataSource"
:remote-operations="false"
:allow-column-reordering="true"
:row-alternation-enabled="true"
:show-borders="true"
@content-ready="onContentReady"
>
<DxColumn
:group-index="0"
data-field="Product"
/>
<DxColumn
data-field="Amount"
caption="Sale Amount"
data-type="number"
format="currency"
alignment="right"
/>
<DxColumn
:allow-grouping="false"
data-field="Discount"
caption="Discount %"
data-type="number"
format="percent"
alignment="right"
cell-template="discountCellTemplate"
css-class="bullet"
/>
<DxColumn
data-field="SaleDate"
data-type="date"
/>
<DxColumn
data-field="Region"
data-type="string"
/>
<DxColumn
data-field="Sector"
data-type="string"
/>
<DxColumn
data-field="Channel"
data-type="string"
/>
<DxColumn
:width="150"
data-field="Customer"
data-type="string"
/>
<DxGroupPanel :visible="true"/>
<DxSearchPanel
:visible="true"
:highlight-case-sensitive="true"
/>
<DxGrouping :auto-expand-all="false"/>
<DxPager
:allowed-page-sizes="pageSizes"
:show-page-size-selector="true"
/>
<DxPaging :page-size="10"/>
<template #discountCellTemplate="{ data: cellData }">
<DiscountCell :cell-data="cellData"/>
</template>
</DxDataGrid>
</template>
<script>
import {
DxDataGrid,
DxColumn,
DxGrouping,
DxGroupPanel,
DxPager,
DxPaging,
DxSearchPanel
} from 'devextreme-vue/data-grid';
import DataSource from 'devextreme/data/data_source';
import 'devextreme/data/odata/store';
import DiscountCell from './DiscountCell.vue';
let collapsed = false;
export default {
components: {
DxDataGrid,
DxColumn,
DxGrouping,
DxGroupPanel,
DxPager,
DxPaging,
DxSearchPanel,
DiscountCell
},
data() {
return {
dataSource: new DataSource({
store: {
type: 'odata',
url: 'https://js.devexpress.com/Demos/SalesViewer/odata/DaySaleDtoes',
beforeSend: function(request) {
request.params.startDate = '2020-05-10';
request.params.endDate = '2020-05-15';
}
}
}),
pageSizes: [10, 25, 50, 100],
onContentReady: function(e) {
if (!collapsed) {
e.component.expandRow(['EnviroCare']);
collapsed = true;
}
}
};
}
};
</script>
<template>
<DxBullet
:show-target="false"
:show-zero-level="true"
:value="cellData.value * 100"
:start-scale-value="0"
:end-scale-value="100"
>
<DxSize
:width="150"
:height="35"
/>
<DxMargin
:top="5"
:bottom="0"
:left="5"
/>
<DxTooltip
:enabled="true"
:padding-top-bottom="2"
:z-index="5"
:customize-tooltip="customizeTooltip"
>
<DxFont :size="18"/>
</DxTooltip>
</DxBullet>
</template>
<script>
import {
DxBullet,
DxFont,
DxMargin,
DxSize,
DxTooltip
} from 'devextreme-vue/bullet';
export default {
components: {
DxBullet,
DxFont,
DxMargin,
DxSize,
DxTooltip
},
props: {
cellData: {
type: Object,
default: () => {}
}
},
data() {
return {
customizeTooltip: function(data) {
return {
text: `${parseInt(data.value)}%`
};
}
};
}
};
</script>
<style>
.dx-datagrid .dx-data-row > td.bullet {
padding-top: 0;
padding-bottom: 0;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app">
</div>
</div>
</body>
</html>
System.config({
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader'
},
'devextreme/localization.js': {
"esModule": true
},
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'vue': 'npm:vue@3.0.0/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.26.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.6',
'devextreme-vue': 'npm:devextreme-vue@20.2.6',
'jszip': 'npm:jszip@3.6.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.10.3/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.18/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.24/dist/dx-gantt.js',
'preact': 'npm:preact@10.5.13/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.13/hooks/dist/hooks.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js'
},
packages: {
'devextreme-vue': {
main: 'index.js'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true
}
});

DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Overview

DevExtreme Angular Data Grid is a responsive grid control with a vast assortment of capabilities, including data editing and validation, searching and filtering, layout customization. It supports native Angular features too: AOT compilation, declarative configuration, TypeScript compile-time checking, and more.

To get started with the DevExtreme DataGrid component, refer to the following tutorial for step-by-step instructions: Getting Started with DataGrid.

Backend API
<dx-data-grid id="gridContainer" [dataSource]="dataSource" [remoteOperations]="false" [allowColumnReordering]="true" [rowAlternationEnabled]="true" [showBorders]="true" [width]="'100%'" (onContentReady)="contentReady($event)" > <dxo-paging [pageSize]="10"></dxo-paging> <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[10, 25, 50, 100]" ></dxo-pager> <dxo-search-panel [visible]="true" [highlightCaseSensitive]="true" ></dxo-search-panel> <dxo-group-panel [visible]="true"></dxo-group-panel> <dxo-grouping [autoExpandAll]="false"></dxo-grouping> <dxi-column dataField="Product" [groupIndex]="0"></dxi-column> <dxi-column dataField="Amount" caption="Sale Amount" dataType="number" format="currency" alignment="right" ></dxi-column> <dxi-column caption="Discount %" dataField="Discount" cellTemplate="discountCellTemplate" dataType="number" format="percent" alignment="right" [allowGrouping]="false" cssClass="bullet" ></dxi-column> <dxi-column dataField="SaleDate" dataType="date"></dxi-column> <dxi-column dataField="Region" dataType="string"></dxi-column> <dxi-column dataField="Sector" dataType="string"></dxi-column> <dxi-column dataField="Channel" dataType="string"></dxi-column> <dxi-column dataField="Customer" dataType="string" [width]="150"></dxi-column> <div *dxTemplate="let d of 'discountCellTemplate'"> <div class="chart-cell"> <dx-bullet [showTarget]="false" [showZeroLevel]="true" [startScaleValue]="0" [endScaleValue]="100" [value]="d.value * 100" > <dxo-size [width]="150" [height]="35"></dxo-size> <dxo-tooltip [enabled]="true" [paddingTopBottom]="2" [customizeTooltip]="customizeTooltip" > <dxo-font [size]="18"></dxo-font> </dxo-tooltip> <dxo-margin [top]="5" [bottom]="0" [left]="5"></dxo-margin> </dx-bullet> </div> </div> </dx-data-grid>
import { NgModule, Component, enableProdMode } from '@angular/core'; import { BrowserModule, BrowserTransferStateModule } from '@angular/platform-browser'; import { platformBrowserDynamic } from '@angular/platform-browser-dynamic'; import DataSource from 'devextreme/data/data_source'; import { DxBulletModule, DxTemplateModule } from 'devextreme-angular'; import { DxDataGridModule, DxDataGridTypes } from 'devextreme-angular/ui/data-grid'; import { Service } from './app.service'; if (!/localhost/.test(document.location.host)) { enableProdMode(); } @Component({ selector: 'demo-app', templateUrl: 'app/app.component.html', styleUrls: ['app/app.component.css'], providers: [Service], }) export class AppComponent { dataSource: DataSource; collapsed = false; contentReady = (e: DxDataGridTypes.ContentReadyEvent) => { if (!this.collapsed) { this.collapsed = true; e.component.expandRow(['EnviroCare']); } }; customizeTooltip = ({ originalValue }: Record<string, string>) => ({ text: `${parseInt(originalValue)}%` }); constructor(service: Service) { this.dataSource = service.getDataSource(); } } @NgModule({ imports: [ BrowserModule, BrowserTransferStateModule, DxDataGridModule, DxTemplateModule, DxBulletModule, ], declarations: [AppComponent], bootstrap: [AppComponent], }) export class AppModule { } platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .dx-datagrid .dx-data-row > td.bullet { padding-top: 0; padding-bottom: 0; }
import { Injectable } from '@angular/core'; import 'devextreme/data/odata/store'; import DataSource from 'devextreme/data/data_source'; @Injectable() export class Service { getDataSource() { return new DataSource({ store: { type: 'odata', version: 2, url: 'https://js.devexpress.com/Demos/SalesViewer/odata/DaySaleDtoes', key: 'Id', beforeSend(request) { const year = new Date().getFullYear() - 1; request.params.startDate = `${year}-05-10`; request.params.endDate = `${year}-5-15`; }, }, }); } }
// In real applications, you should not transpile code in the browser. // You can see how to create your own application with Angular and DevExtreme here: // https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/ window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, }, meta: { 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, }, paths: { 'npm:': 'https://unpkg.com/', }, map: { 'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', '@angular/core': 'npm:@angular/core@12.2.17', '@angular/platform-browser': 'npm:@angular/platform-browser@12.2.17', '@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.17', '@angular/forms': 'npm:@angular/forms@12.2.17', '@angular/common': 'npm:@angular/common@12.2.17', '@angular/compiler': 'npm:@angular/compiler@12.2.17', 'tslib': 'npm:tslib@2.6.2/tslib.js', 'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js', 'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@23.2.5/cjs', 'devextreme/bundles/dx.all': 'npm:devextreme@23.2.5/bundles/dx.all.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.6.4/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.5', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.51', 'devextreme-angular': 'npm:devextreme-angular@23.2.5', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.4/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js', }, packages: { 'app': { main: './app.component.ts', defaultExtension: 'ts', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, 'rxjs': { defaultExtension: 'js', }, 'rxjs/operators': { defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.12/inferno/package.json', 'npm:@angular/*/package.json', 'npm:@angular/common@12.2.17/*/package.json', 'npm:rxjs@7.5.3/package.json', 'npm:rxjs@7.5.3/operators/package.json', 'npm:devextreme-angular@23.2.5/*/package.json', 'npm:devextreme-angular@23.2.5/ui/*/package.json', 'npm:devextreme-angular@23.2.5/package.json', 'npm:devexpress-diagram@2.2.5/package.json', 'npm:devexpress-gantt@4.1.51/package.json', ], }; System.config(window.config);
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.5/css/dx.light.css" /> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script> <script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script src="config.js"></script> <script> System.import("app").catch(console.error.bind(console)); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <demo-app>Loading...</demo-app> </div> </body> </html>